// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"gochassis/ent/chat"
	"gochassis/ent/chatroom"
	"gochassis/ent/post"
	"gochassis/ent/predicate"
	"gochassis/ent/profile"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// ProfileUpdate is the builder for updating Profile entities.
type ProfileUpdate struct {
	config
	hooks    []Hook
	mutation *ProfileMutation
}

// Where appends a list predicates to the ProfileUpdate builder.
func (pu *ProfileUpdate) Where(ps ...predicate.Profile) *ProfileUpdate {
	pu.mutation.Where(ps...)
	return pu
}

// SetPhoneNumber sets the "phone_number" field.
func (pu *ProfileUpdate) SetPhoneNumber(s string) *ProfileUpdate {
	pu.mutation.SetPhoneNumber(s)
	return pu
}

// SetNillablePhoneNumber sets the "phone_number" field if the given value is not nil.
func (pu *ProfileUpdate) SetNillablePhoneNumber(s *string) *ProfileUpdate {
	if s != nil {
		pu.SetPhoneNumber(*s)
	}
	return pu
}

// ClearPhoneNumber clears the value of the "phone_number" field.
func (pu *ProfileUpdate) ClearPhoneNumber() *ProfileUpdate {
	pu.mutation.ClearPhoneNumber()
	return pu
}

// SetDeviceID sets the "device_id" field.
func (pu *ProfileUpdate) SetDeviceID(s string) *ProfileUpdate {
	pu.mutation.SetDeviceID(s)
	return pu
}

// SetDisplayname sets the "displayname" field.
func (pu *ProfileUpdate) SetDisplayname(s string) *ProfileUpdate {
	pu.mutation.SetDisplayname(s)
	return pu
}

// SetPassword sets the "password" field.
func (pu *ProfileUpdate) SetPassword(s string) *ProfileUpdate {
	pu.mutation.SetPassword(s)
	return pu
}

// SetNillablePassword sets the "password" field if the given value is not nil.
func (pu *ProfileUpdate) SetNillablePassword(s *string) *ProfileUpdate {
	if s != nil {
		pu.SetPassword(*s)
	}
	return pu
}

// ClearPassword clears the value of the "password" field.
func (pu *ProfileUpdate) ClearPassword() *ProfileUpdate {
	pu.mutation.ClearPassword()
	return pu
}

// SetBirthYear sets the "birth_year" field.
func (pu *ProfileUpdate) SetBirthYear(i int16) *ProfileUpdate {
	pu.mutation.ResetBirthYear()
	pu.mutation.SetBirthYear(i)
	return pu
}

// SetNillableBirthYear sets the "birth_year" field if the given value is not nil.
func (pu *ProfileUpdate) SetNillableBirthYear(i *int16) *ProfileUpdate {
	if i != nil {
		pu.SetBirthYear(*i)
	}
	return pu
}

// AddBirthYear adds i to the "birth_year" field.
func (pu *ProfileUpdate) AddBirthYear(i int16) *ProfileUpdate {
	pu.mutation.AddBirthYear(i)
	return pu
}

// ClearBirthYear clears the value of the "birth_year" field.
func (pu *ProfileUpdate) ClearBirthYear() *ProfileUpdate {
	pu.mutation.ClearBirthYear()
	return pu
}

// SetGender sets the "gender" field.
func (pu *ProfileUpdate) SetGender(s string) *ProfileUpdate {
	pu.mutation.SetGender(s)
	return pu
}

// SetNillableGender sets the "gender" field if the given value is not nil.
func (pu *ProfileUpdate) SetNillableGender(s *string) *ProfileUpdate {
	if s != nil {
		pu.SetGender(*s)
	}
	return pu
}

// ClearGender clears the value of the "gender" field.
func (pu *ProfileUpdate) ClearGender() *ProfileUpdate {
	pu.mutation.ClearGender()
	return pu
}

// SetCreatedAt sets the "created_at" field.
func (pu *ProfileUpdate) SetCreatedAt(t time.Time) *ProfileUpdate {
	pu.mutation.SetCreatedAt(t)
	return pu
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (pu *ProfileUpdate) SetNillableCreatedAt(t *time.Time) *ProfileUpdate {
	if t != nil {
		pu.SetCreatedAt(*t)
	}
	return pu
}

// SetUpdatedAt sets the "updated_at" field.
func (pu *ProfileUpdate) SetUpdatedAt(t time.Time) *ProfileUpdate {
	pu.mutation.SetUpdatedAt(t)
	return pu
}

// SetDeletedAt sets the "deleted_at" field.
func (pu *ProfileUpdate) SetDeletedAt(t time.Time) *ProfileUpdate {
	pu.mutation.SetDeletedAt(t)
	return pu
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (pu *ProfileUpdate) SetNillableDeletedAt(t *time.Time) *ProfileUpdate {
	if t != nil {
		pu.SetDeletedAt(*t)
	}
	return pu
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (pu *ProfileUpdate) ClearDeletedAt() *ProfileUpdate {
	pu.mutation.ClearDeletedAt()
	return pu
}

// AddChatIDs adds the "chats" edge to the Chat entity by IDs.
func (pu *ProfileUpdate) AddChatIDs(ids ...int) *ProfileUpdate {
	pu.mutation.AddChatIDs(ids...)
	return pu
}

// AddChats adds the "chats" edges to the Chat entity.
func (pu *ProfileUpdate) AddChats(c ...*Chat) *ProfileUpdate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return pu.AddChatIDs(ids...)
}

// AddChatRoomIDs adds the "chat_rooms" edge to the ChatRoom entity by IDs.
func (pu *ProfileUpdate) AddChatRoomIDs(ids ...int) *ProfileUpdate {
	pu.mutation.AddChatRoomIDs(ids...)
	return pu
}

// AddChatRooms adds the "chat_rooms" edges to the ChatRoom entity.
func (pu *ProfileUpdate) AddChatRooms(c ...*ChatRoom) *ProfileUpdate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return pu.AddChatRoomIDs(ids...)
}

// AddPostIDs adds the "posts" edge to the Post entity by IDs.
func (pu *ProfileUpdate) AddPostIDs(ids ...int) *ProfileUpdate {
	pu.mutation.AddPostIDs(ids...)
	return pu
}

// AddPosts adds the "posts" edges to the Post entity.
func (pu *ProfileUpdate) AddPosts(p ...*Post) *ProfileUpdate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return pu.AddPostIDs(ids...)
}

// AddLikeIDs adds the "likes" edge to the Post entity by IDs.
func (pu *ProfileUpdate) AddLikeIDs(ids ...int) *ProfileUpdate {
	pu.mutation.AddLikeIDs(ids...)
	return pu
}

// AddLikes adds the "likes" edges to the Post entity.
func (pu *ProfileUpdate) AddLikes(p ...*Post) *ProfileUpdate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return pu.AddLikeIDs(ids...)
}

// Mutation returns the ProfileMutation object of the builder.
func (pu *ProfileUpdate) Mutation() *ProfileMutation {
	return pu.mutation
}

// ClearChats clears all "chats" edges to the Chat entity.
func (pu *ProfileUpdate) ClearChats() *ProfileUpdate {
	pu.mutation.ClearChats()
	return pu
}

// RemoveChatIDs removes the "chats" edge to Chat entities by IDs.
func (pu *ProfileUpdate) RemoveChatIDs(ids ...int) *ProfileUpdate {
	pu.mutation.RemoveChatIDs(ids...)
	return pu
}

// RemoveChats removes "chats" edges to Chat entities.
func (pu *ProfileUpdate) RemoveChats(c ...*Chat) *ProfileUpdate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return pu.RemoveChatIDs(ids...)
}

// ClearChatRooms clears all "chat_rooms" edges to the ChatRoom entity.
func (pu *ProfileUpdate) ClearChatRooms() *ProfileUpdate {
	pu.mutation.ClearChatRooms()
	return pu
}

// RemoveChatRoomIDs removes the "chat_rooms" edge to ChatRoom entities by IDs.
func (pu *ProfileUpdate) RemoveChatRoomIDs(ids ...int) *ProfileUpdate {
	pu.mutation.RemoveChatRoomIDs(ids...)
	return pu
}

// RemoveChatRooms removes "chat_rooms" edges to ChatRoom entities.
func (pu *ProfileUpdate) RemoveChatRooms(c ...*ChatRoom) *ProfileUpdate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return pu.RemoveChatRoomIDs(ids...)
}

// ClearPosts clears all "posts" edges to the Post entity.
func (pu *ProfileUpdate) ClearPosts() *ProfileUpdate {
	pu.mutation.ClearPosts()
	return pu
}

// RemovePostIDs removes the "posts" edge to Post entities by IDs.
func (pu *ProfileUpdate) RemovePostIDs(ids ...int) *ProfileUpdate {
	pu.mutation.RemovePostIDs(ids...)
	return pu
}

// RemovePosts removes "posts" edges to Post entities.
func (pu *ProfileUpdate) RemovePosts(p ...*Post) *ProfileUpdate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return pu.RemovePostIDs(ids...)
}

// ClearLikes clears all "likes" edges to the Post entity.
func (pu *ProfileUpdate) ClearLikes() *ProfileUpdate {
	pu.mutation.ClearLikes()
	return pu
}

// RemoveLikeIDs removes the "likes" edge to Post entities by IDs.
func (pu *ProfileUpdate) RemoveLikeIDs(ids ...int) *ProfileUpdate {
	pu.mutation.RemoveLikeIDs(ids...)
	return pu
}

// RemoveLikes removes "likes" edges to Post entities.
func (pu *ProfileUpdate) RemoveLikes(p ...*Post) *ProfileUpdate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return pu.RemoveLikeIDs(ids...)
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (pu *ProfileUpdate) Save(ctx context.Context) (int, error) {
	pu.defaults()
	return withHooks[int, ProfileMutation](ctx, pu.sqlSave, pu.mutation, pu.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (pu *ProfileUpdate) SaveX(ctx context.Context) int {
	affected, err := pu.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (pu *ProfileUpdate) Exec(ctx context.Context) error {
	_, err := pu.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (pu *ProfileUpdate) ExecX(ctx context.Context) {
	if err := pu.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (pu *ProfileUpdate) defaults() {
	if _, ok := pu.mutation.UpdatedAt(); !ok {
		v := profile.UpdateDefaultUpdatedAt()
		pu.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (pu *ProfileUpdate) check() error {
	if v, ok := pu.mutation.DeviceID(); ok {
		if err := profile.DeviceIDValidator(v); err != nil {
			return &ValidationError{Name: "device_id", err: fmt.Errorf(`ent: validator failed for field "Profile.device_id": %w`, err)}
		}
	}
	if v, ok := pu.mutation.Displayname(); ok {
		if err := profile.DisplaynameValidator(v); err != nil {
			return &ValidationError{Name: "displayname", err: fmt.Errorf(`ent: validator failed for field "Profile.displayname": %w`, err)}
		}
	}
	return nil
}

func (pu *ProfileUpdate) sqlSave(ctx context.Context) (n int, err error) {
	if err := pu.check(); err != nil {
		return n, err
	}
	_spec := sqlgraph.NewUpdateSpec(profile.Table, profile.Columns, sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt))
	if ps := pu.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := pu.mutation.PhoneNumber(); ok {
		_spec.SetField(profile.FieldPhoneNumber, field.TypeString, value)
	}
	if pu.mutation.PhoneNumberCleared() {
		_spec.ClearField(profile.FieldPhoneNumber, field.TypeString)
	}
	if value, ok := pu.mutation.DeviceID(); ok {
		_spec.SetField(profile.FieldDeviceID, field.TypeString, value)
	}
	if value, ok := pu.mutation.Displayname(); ok {
		_spec.SetField(profile.FieldDisplayname, field.TypeString, value)
	}
	if value, ok := pu.mutation.Password(); ok {
		_spec.SetField(profile.FieldPassword, field.TypeString, value)
	}
	if pu.mutation.PasswordCleared() {
		_spec.ClearField(profile.FieldPassword, field.TypeString)
	}
	if value, ok := pu.mutation.BirthYear(); ok {
		_spec.SetField(profile.FieldBirthYear, field.TypeInt16, value)
	}
	if value, ok := pu.mutation.AddedBirthYear(); ok {
		_spec.AddField(profile.FieldBirthYear, field.TypeInt16, value)
	}
	if pu.mutation.BirthYearCleared() {
		_spec.ClearField(profile.FieldBirthYear, field.TypeInt16)
	}
	if value, ok := pu.mutation.Gender(); ok {
		_spec.SetField(profile.FieldGender, field.TypeString, value)
	}
	if pu.mutation.GenderCleared() {
		_spec.ClearField(profile.FieldGender, field.TypeString)
	}
	if value, ok := pu.mutation.CreatedAt(); ok {
		_spec.SetField(profile.FieldCreatedAt, field.TypeTime, value)
	}
	if value, ok := pu.mutation.UpdatedAt(); ok {
		_spec.SetField(profile.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := pu.mutation.DeletedAt(); ok {
		_spec.SetField(profile.FieldDeletedAt, field.TypeTime, value)
	}
	if pu.mutation.DeletedAtCleared() {
		_spec.ClearField(profile.FieldDeletedAt, field.TypeTime)
	}
	if pu.mutation.ChatsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.ChatsTable,
			Columns: []string{profile.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.RemovedChatsIDs(); len(nodes) > 0 && !pu.mutation.ChatsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.ChatsTable,
			Columns: []string{profile.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.ChatsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.ChatsTable,
			Columns: []string{profile.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if pu.mutation.ChatRoomsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.ChatRoomsTable,
			Columns: profile.ChatRoomsPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.RemovedChatRoomsIDs(); len(nodes) > 0 && !pu.mutation.ChatRoomsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.ChatRoomsTable,
			Columns: profile.ChatRoomsPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.ChatRoomsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.ChatRoomsTable,
			Columns: profile.ChatRoomsPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if pu.mutation.PostsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.PostsTable,
			Columns: []string{profile.PostsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.RemovedPostsIDs(); len(nodes) > 0 && !pu.mutation.PostsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.PostsTable,
			Columns: []string{profile.PostsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.PostsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.PostsTable,
			Columns: []string{profile.PostsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if pu.mutation.LikesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.LikesTable,
			Columns: profile.LikesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.RemovedLikesIDs(); len(nodes) > 0 && !pu.mutation.LikesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.LikesTable,
			Columns: profile.LikesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := pu.mutation.LikesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.LikesTable,
			Columns: profile.LikesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if n, err = sqlgraph.UpdateNodes(ctx, pu.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{profile.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	pu.mutation.done = true
	return n, nil
}

// ProfileUpdateOne is the builder for updating a single Profile entity.
type ProfileUpdateOne struct {
	config
	fields   []string
	hooks    []Hook
	mutation *ProfileMutation
}

// SetPhoneNumber sets the "phone_number" field.
func (puo *ProfileUpdateOne) SetPhoneNumber(s string) *ProfileUpdateOne {
	puo.mutation.SetPhoneNumber(s)
	return puo
}

// SetNillablePhoneNumber sets the "phone_number" field if the given value is not nil.
func (puo *ProfileUpdateOne) SetNillablePhoneNumber(s *string) *ProfileUpdateOne {
	if s != nil {
		puo.SetPhoneNumber(*s)
	}
	return puo
}

// ClearPhoneNumber clears the value of the "phone_number" field.
func (puo *ProfileUpdateOne) ClearPhoneNumber() *ProfileUpdateOne {
	puo.mutation.ClearPhoneNumber()
	return puo
}

// SetDeviceID sets the "device_id" field.
func (puo *ProfileUpdateOne) SetDeviceID(s string) *ProfileUpdateOne {
	puo.mutation.SetDeviceID(s)
	return puo
}

// SetDisplayname sets the "displayname" field.
func (puo *ProfileUpdateOne) SetDisplayname(s string) *ProfileUpdateOne {
	puo.mutation.SetDisplayname(s)
	return puo
}

// SetPassword sets the "password" field.
func (puo *ProfileUpdateOne) SetPassword(s string) *ProfileUpdateOne {
	puo.mutation.SetPassword(s)
	return puo
}

// SetNillablePassword sets the "password" field if the given value is not nil.
func (puo *ProfileUpdateOne) SetNillablePassword(s *string) *ProfileUpdateOne {
	if s != nil {
		puo.SetPassword(*s)
	}
	return puo
}

// ClearPassword clears the value of the "password" field.
func (puo *ProfileUpdateOne) ClearPassword() *ProfileUpdateOne {
	puo.mutation.ClearPassword()
	return puo
}

// SetBirthYear sets the "birth_year" field.
func (puo *ProfileUpdateOne) SetBirthYear(i int16) *ProfileUpdateOne {
	puo.mutation.ResetBirthYear()
	puo.mutation.SetBirthYear(i)
	return puo
}

// SetNillableBirthYear sets the "birth_year" field if the given value is not nil.
func (puo *ProfileUpdateOne) SetNillableBirthYear(i *int16) *ProfileUpdateOne {
	if i != nil {
		puo.SetBirthYear(*i)
	}
	return puo
}

// AddBirthYear adds i to the "birth_year" field.
func (puo *ProfileUpdateOne) AddBirthYear(i int16) *ProfileUpdateOne {
	puo.mutation.AddBirthYear(i)
	return puo
}

// ClearBirthYear clears the value of the "birth_year" field.
func (puo *ProfileUpdateOne) ClearBirthYear() *ProfileUpdateOne {
	puo.mutation.ClearBirthYear()
	return puo
}

// SetGender sets the "gender" field.
func (puo *ProfileUpdateOne) SetGender(s string) *ProfileUpdateOne {
	puo.mutation.SetGender(s)
	return puo
}

// SetNillableGender sets the "gender" field if the given value is not nil.
func (puo *ProfileUpdateOne) SetNillableGender(s *string) *ProfileUpdateOne {
	if s != nil {
		puo.SetGender(*s)
	}
	return puo
}

// ClearGender clears the value of the "gender" field.
func (puo *ProfileUpdateOne) ClearGender() *ProfileUpdateOne {
	puo.mutation.ClearGender()
	return puo
}

// SetCreatedAt sets the "created_at" field.
func (puo *ProfileUpdateOne) SetCreatedAt(t time.Time) *ProfileUpdateOne {
	puo.mutation.SetCreatedAt(t)
	return puo
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (puo *ProfileUpdateOne) SetNillableCreatedAt(t *time.Time) *ProfileUpdateOne {
	if t != nil {
		puo.SetCreatedAt(*t)
	}
	return puo
}

// SetUpdatedAt sets the "updated_at" field.
func (puo *ProfileUpdateOne) SetUpdatedAt(t time.Time) *ProfileUpdateOne {
	puo.mutation.SetUpdatedAt(t)
	return puo
}

// SetDeletedAt sets the "deleted_at" field.
func (puo *ProfileUpdateOne) SetDeletedAt(t time.Time) *ProfileUpdateOne {
	puo.mutation.SetDeletedAt(t)
	return puo
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (puo *ProfileUpdateOne) SetNillableDeletedAt(t *time.Time) *ProfileUpdateOne {
	if t != nil {
		puo.SetDeletedAt(*t)
	}
	return puo
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (puo *ProfileUpdateOne) ClearDeletedAt() *ProfileUpdateOne {
	puo.mutation.ClearDeletedAt()
	return puo
}

// AddChatIDs adds the "chats" edge to the Chat entity by IDs.
func (puo *ProfileUpdateOne) AddChatIDs(ids ...int) *ProfileUpdateOne {
	puo.mutation.AddChatIDs(ids...)
	return puo
}

// AddChats adds the "chats" edges to the Chat entity.
func (puo *ProfileUpdateOne) AddChats(c ...*Chat) *ProfileUpdateOne {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return puo.AddChatIDs(ids...)
}

// AddChatRoomIDs adds the "chat_rooms" edge to the ChatRoom entity by IDs.
func (puo *ProfileUpdateOne) AddChatRoomIDs(ids ...int) *ProfileUpdateOne {
	puo.mutation.AddChatRoomIDs(ids...)
	return puo
}

// AddChatRooms adds the "chat_rooms" edges to the ChatRoom entity.
func (puo *ProfileUpdateOne) AddChatRooms(c ...*ChatRoom) *ProfileUpdateOne {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return puo.AddChatRoomIDs(ids...)
}

// AddPostIDs adds the "posts" edge to the Post entity by IDs.
func (puo *ProfileUpdateOne) AddPostIDs(ids ...int) *ProfileUpdateOne {
	puo.mutation.AddPostIDs(ids...)
	return puo
}

// AddPosts adds the "posts" edges to the Post entity.
func (puo *ProfileUpdateOne) AddPosts(p ...*Post) *ProfileUpdateOne {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return puo.AddPostIDs(ids...)
}

// AddLikeIDs adds the "likes" edge to the Post entity by IDs.
func (puo *ProfileUpdateOne) AddLikeIDs(ids ...int) *ProfileUpdateOne {
	puo.mutation.AddLikeIDs(ids...)
	return puo
}

// AddLikes adds the "likes" edges to the Post entity.
func (puo *ProfileUpdateOne) AddLikes(p ...*Post) *ProfileUpdateOne {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return puo.AddLikeIDs(ids...)
}

// Mutation returns the ProfileMutation object of the builder.
func (puo *ProfileUpdateOne) Mutation() *ProfileMutation {
	return puo.mutation
}

// ClearChats clears all "chats" edges to the Chat entity.
func (puo *ProfileUpdateOne) ClearChats() *ProfileUpdateOne {
	puo.mutation.ClearChats()
	return puo
}

// RemoveChatIDs removes the "chats" edge to Chat entities by IDs.
func (puo *ProfileUpdateOne) RemoveChatIDs(ids ...int) *ProfileUpdateOne {
	puo.mutation.RemoveChatIDs(ids...)
	return puo
}

// RemoveChats removes "chats" edges to Chat entities.
func (puo *ProfileUpdateOne) RemoveChats(c ...*Chat) *ProfileUpdateOne {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return puo.RemoveChatIDs(ids...)
}

// ClearChatRooms clears all "chat_rooms" edges to the ChatRoom entity.
func (puo *ProfileUpdateOne) ClearChatRooms() *ProfileUpdateOne {
	puo.mutation.ClearChatRooms()
	return puo
}

// RemoveChatRoomIDs removes the "chat_rooms" edge to ChatRoom entities by IDs.
func (puo *ProfileUpdateOne) RemoveChatRoomIDs(ids ...int) *ProfileUpdateOne {
	puo.mutation.RemoveChatRoomIDs(ids...)
	return puo
}

// RemoveChatRooms removes "chat_rooms" edges to ChatRoom entities.
func (puo *ProfileUpdateOne) RemoveChatRooms(c ...*ChatRoom) *ProfileUpdateOne {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return puo.RemoveChatRoomIDs(ids...)
}

// ClearPosts clears all "posts" edges to the Post entity.
func (puo *ProfileUpdateOne) ClearPosts() *ProfileUpdateOne {
	puo.mutation.ClearPosts()
	return puo
}

// RemovePostIDs removes the "posts" edge to Post entities by IDs.
func (puo *ProfileUpdateOne) RemovePostIDs(ids ...int) *ProfileUpdateOne {
	puo.mutation.RemovePostIDs(ids...)
	return puo
}

// RemovePosts removes "posts" edges to Post entities.
func (puo *ProfileUpdateOne) RemovePosts(p ...*Post) *ProfileUpdateOne {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return puo.RemovePostIDs(ids...)
}

// ClearLikes clears all "likes" edges to the Post entity.
func (puo *ProfileUpdateOne) ClearLikes() *ProfileUpdateOne {
	puo.mutation.ClearLikes()
	return puo
}

// RemoveLikeIDs removes the "likes" edge to Post entities by IDs.
func (puo *ProfileUpdateOne) RemoveLikeIDs(ids ...int) *ProfileUpdateOne {
	puo.mutation.RemoveLikeIDs(ids...)
	return puo
}

// RemoveLikes removes "likes" edges to Post entities.
func (puo *ProfileUpdateOne) RemoveLikes(p ...*Post) *ProfileUpdateOne {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return puo.RemoveLikeIDs(ids...)
}

// Where appends a list predicates to the ProfileUpdate builder.
func (puo *ProfileUpdateOne) Where(ps ...predicate.Profile) *ProfileUpdateOne {
	puo.mutation.Where(ps...)
	return puo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (puo *ProfileUpdateOne) Select(field string, fields ...string) *ProfileUpdateOne {
	puo.fields = append([]string{field}, fields...)
	return puo
}

// Save executes the query and returns the updated Profile entity.
func (puo *ProfileUpdateOne) Save(ctx context.Context) (*Profile, error) {
	puo.defaults()
	return withHooks[*Profile, ProfileMutation](ctx, puo.sqlSave, puo.mutation, puo.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (puo *ProfileUpdateOne) SaveX(ctx context.Context) *Profile {
	node, err := puo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (puo *ProfileUpdateOne) Exec(ctx context.Context) error {
	_, err := puo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (puo *ProfileUpdateOne) ExecX(ctx context.Context) {
	if err := puo.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (puo *ProfileUpdateOne) defaults() {
	if _, ok := puo.mutation.UpdatedAt(); !ok {
		v := profile.UpdateDefaultUpdatedAt()
		puo.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (puo *ProfileUpdateOne) check() error {
	if v, ok := puo.mutation.DeviceID(); ok {
		if err := profile.DeviceIDValidator(v); err != nil {
			return &ValidationError{Name: "device_id", err: fmt.Errorf(`ent: validator failed for field "Profile.device_id": %w`, err)}
		}
	}
	if v, ok := puo.mutation.Displayname(); ok {
		if err := profile.DisplaynameValidator(v); err != nil {
			return &ValidationError{Name: "displayname", err: fmt.Errorf(`ent: validator failed for field "Profile.displayname": %w`, err)}
		}
	}
	return nil
}

func (puo *ProfileUpdateOne) sqlSave(ctx context.Context) (_node *Profile, err error) {
	if err := puo.check(); err != nil {
		return _node, err
	}
	_spec := sqlgraph.NewUpdateSpec(profile.Table, profile.Columns, sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt))
	id, ok := puo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "Profile.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := puo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, profile.FieldID)
		for _, f := range fields {
			if !profile.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != profile.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := puo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := puo.mutation.PhoneNumber(); ok {
		_spec.SetField(profile.FieldPhoneNumber, field.TypeString, value)
	}
	if puo.mutation.PhoneNumberCleared() {
		_spec.ClearField(profile.FieldPhoneNumber, field.TypeString)
	}
	if value, ok := puo.mutation.DeviceID(); ok {
		_spec.SetField(profile.FieldDeviceID, field.TypeString, value)
	}
	if value, ok := puo.mutation.Displayname(); ok {
		_spec.SetField(profile.FieldDisplayname, field.TypeString, value)
	}
	if value, ok := puo.mutation.Password(); ok {
		_spec.SetField(profile.FieldPassword, field.TypeString, value)
	}
	if puo.mutation.PasswordCleared() {
		_spec.ClearField(profile.FieldPassword, field.TypeString)
	}
	if value, ok := puo.mutation.BirthYear(); ok {
		_spec.SetField(profile.FieldBirthYear, field.TypeInt16, value)
	}
	if value, ok := puo.mutation.AddedBirthYear(); ok {
		_spec.AddField(profile.FieldBirthYear, field.TypeInt16, value)
	}
	if puo.mutation.BirthYearCleared() {
		_spec.ClearField(profile.FieldBirthYear, field.TypeInt16)
	}
	if value, ok := puo.mutation.Gender(); ok {
		_spec.SetField(profile.FieldGender, field.TypeString, value)
	}
	if puo.mutation.GenderCleared() {
		_spec.ClearField(profile.FieldGender, field.TypeString)
	}
	if value, ok := puo.mutation.CreatedAt(); ok {
		_spec.SetField(profile.FieldCreatedAt, field.TypeTime, value)
	}
	if value, ok := puo.mutation.UpdatedAt(); ok {
		_spec.SetField(profile.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := puo.mutation.DeletedAt(); ok {
		_spec.SetField(profile.FieldDeletedAt, field.TypeTime, value)
	}
	if puo.mutation.DeletedAtCleared() {
		_spec.ClearField(profile.FieldDeletedAt, field.TypeTime)
	}
	if puo.mutation.ChatsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.ChatsTable,
			Columns: []string{profile.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.RemovedChatsIDs(); len(nodes) > 0 && !puo.mutation.ChatsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.ChatsTable,
			Columns: []string{profile.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.ChatsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.ChatsTable,
			Columns: []string{profile.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if puo.mutation.ChatRoomsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.ChatRoomsTable,
			Columns: profile.ChatRoomsPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.RemovedChatRoomsIDs(); len(nodes) > 0 && !puo.mutation.ChatRoomsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.ChatRoomsTable,
			Columns: profile.ChatRoomsPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.ChatRoomsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.ChatRoomsTable,
			Columns: profile.ChatRoomsPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if puo.mutation.PostsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.PostsTable,
			Columns: []string{profile.PostsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.RemovedPostsIDs(); len(nodes) > 0 && !puo.mutation.PostsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.PostsTable,
			Columns: []string{profile.PostsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.PostsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.PostsTable,
			Columns: []string{profile.PostsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if puo.mutation.LikesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.LikesTable,
			Columns: profile.LikesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.RemovedLikesIDs(); len(nodes) > 0 && !puo.mutation.LikesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.LikesTable,
			Columns: profile.LikesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := puo.mutation.LikesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.LikesTable,
			Columns: profile.LikesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_node = &Profile{config: puo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, puo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{profile.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	puo.mutation.done = true
	return _node, nil
}
